package ram.kulkarni.war.sql.demo;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;


/**
 * 
 * @author Ram Kulkarni (ramkulkarni.com)
 *
 */
public class SQLDemoUtils {

	public static String openFileDialog (String initPath, boolean isOpen)
	{
		int style = SWT.OPEN;
		if (!isOpen)
			style = SWT.SAVE;
		FileDialog fileDlg = new FileDialog(Display.getCurrent().getActiveShell(), style);
		 
		if (initPath != null)
			fileDlg.setFilterPath(initPath);
		return fileDlg.open();
		
	
	}
	
	private static File getDemoPropertyFile (String appPath, boolean create) throws Exception
	{
		File file = new File(appPath);
		
		if (!file.exists())
			throw new Exception("File " + appPath + " does not exist");
		
		File dir = file;
		if (file.isFile())
			dir = file.getParentFile();
		
		File propertyFile = new File(dir.getAbsolutePath() + file.separatorChar + "sqldbdemo.properties");
		if (!propertyFile.exists())
		{
			if (!create)
				return null;
			if (!propertyFile.createNewFile())
				return null;
		}
		return propertyFile;
	}
	
	public static String getSavedDBPath (String appPath) throws Exception
	{
		File propertyFile = getDemoPropertyFile(appPath,false);
		if (propertyFile == null)
			return null;
		
		Properties props = new Properties();
		FileInputStream inStream = new FileInputStream(propertyFile);
		props.load(inStream);
		String dbPath = props.getProperty("dbpath");
		inStream.close();
		return dbPath;
	}
	
	public static void saveDBPath (String appPath, String dbPath) throws Exception
	{
		File propertyFile = getDemoPropertyFile(appPath, true);
		if (propertyFile == null)
			return ;
		
		Properties props = new Properties();
		FileInputStream inStream = new FileInputStream(propertyFile);
		props.load(inStream);
		inStream.close();
		props.setProperty("dbpath", dbPath);
		FileOutputStream outStream = new FileOutputStream(propertyFile);
		props.store(outStream, null);
		outStream.close();
	}
}
