package ram.kulkarni.war.sql.demo;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;

/**
 * 
 * @author Ram Kulkarni (ramkulkarni.com)
 *
 */
public class SQLiteManger {

	protected Connection con = null;
	
	public SQLiteManger(String filePath) throws Exception
	{
		Class.forName("org.sqlite.JDBC");
		
		File file = new File(filePath);
		if (!file.exists())
			file.createNewFile();
		
		con = DriverManager.getConnection("jdbc:sqlite:" + filePath);
		compactDB();
	}
	
    private void compactDB() throws Exception {
        if (con != null) {
            //vacuum
            Statement stmt = con.createStatement();
            stmt.execute("VACUUM");
        }
    }	
    
    public void close() throws Exception
    {
    	if (con != null)
    	{
    		compactDB();
    		con.close();
    	}
    }

}
